#!/usr/bin/python

# myphotos.py is Copyright Philip Beadling, June 2007.
# Users are permitted to use it for non-profit purposes only.
# Users may include this file as part of larger projects only if this file is included
# in its entirety and Philip Beadling is clearly credited in the larger project's source and documentation.

import facebook as fb
from glob import glob
from easygui import diropenbox, msgbox
from os import sep

def upload( folders, facebook ):
	for folder in folders:
		photos = glob( folder + sep + "*.jpg" )
		photos += glob( folder + sep + "*.JPG" )
		
		# Album Name - glob uses '/' even for Windows
		albumRootName = folder.split('/')[-1]
		
		numberOfSubAlbums = ( len(photos) / 60 ) + 1
		albumPhotoDict = {}
		index = 0
		if numberOfSubAlbums > 1:
			print albumRootName, "Contains more than 60 photos, splitting up to get around Facebook restrictions..." 
			for album in [ albumRootName + ' Part ' + str(albumNumber+1) for albumNumber in range(0,numberOfSubAlbums) ]:
				albumPhotoDict[ album ] = photos[index:index+60]
				index += 60
			print "NOTE: Albums may not be uploaded in chronological order, this doesn't matter..."
		else:
			print albumRootName, "contains less than 60 photos, no need to split it up..."
			albumPhotoDict[ albumRootName ] = photos
			
		fbAlbums = []
		for albumDictionary in facebook.photos.getAlbums():
			fbAlbums.append( albumDictionary['name'] )
		
		for albumName in albumPhotoDict.keys():	 
			if albumName in fbAlbums:
				print albumName, "already exists, skipping!"
				continue
			print "Creating new album:", albumName
			aid = facebook.photos.createAlbum( albumName )['aid']
			for photo in albumPhotoDict[ albumName ]:
				initialCaptionName = photo.split('/')[-1].split('.')[0]
				print "Uploading:", initialCaptionName
				facebook.photos.upload( photo, aid, initialCaptionName )



def main():
	api_key    = '53897d3822105f2c59a27646f43aea66'
	secret_key = 'd7b948a8e23af271186d4e88f0aa0fad'
	msgbox("NOTE: Run this app from the command line, you'll need to see stdout", "myphotos v0.1a - Philip Beadling")
	print "myphotos v0.1a - by Philip Beadling"
	print "Hello user - excuse the dirty interface, it will suffice for now."
	print "You should be seeing a popup directory box - 'OK' a directory to upload,"
	print "and then another, and so on, click 'Cancel' when you're done."
	result = sep
	directoryList = []
	# Nasty - first keeps Windows happy, second keeps Mac happy.
	# EasyGUI is not consistent across operating systems!
	while result != None and len(result) != 0:
		result = diropenbox(msg="Select Photo Directory", title="Select Photo Directory", argInitialDir=result+sep+'..')
		print result
		directoryList.append( result )
	directoryList = directoryList[:-1]
	print "Thanks for that, I'm going to create", len(directoryList), "new album(s)"
	print "one for each directory below:"
	print
	for dir in directoryList: print "Directory:", dir, "||| Album name:", dir.split('/')[-1]
	print
	print
	facebook = fb.Facebook( api_key, secret_key )
	print "Creating authentication token..."
	facebook.auth.createToken()
	# Show login window
	print "Logging into Facebook - please enter your credentials into the popped up web browser..."
	facebook.login()

	#Login to the window, then press enter
	print 'After logging in, press enter...'
	raw_input()
	print "Authenticating session..."
	facebook.auth.getSession()
	print 'Your UID:', facebook.uid
	
	if len(directoryList) > 0:
		upload( directoryList, facebook )
	else:
		print "You didn't select any directories - dumb ass!"
	print "All done!"


if __name__ == '__main__':
    main()

